;===============================================================================
; GIFLIB v1.0 by Exagone - Demo with GIF file
;===============================================================================
; Example of how to use the GIF library to display a GIF File from a file 
; resource. 
; (C) Copyright 2000 by Exagone.
; [best viewed width tab stop = 4 spaces and syntax highlighting]

.486
.model flat, stdcall
option casemap:none

includelib 	\masm32\lib\kernel32.lib
includelib 	\masm32\lib\user32.lib
includelib 	\masm32\lib\gdi32.lib
include		\masm32\include\kernel32.inc
include		\masm32\include\user32.inc
include		\masm32\include\gdi32.inc
include		\masm32\include\windows.inc
includelib	..\..\giflib.lib				; !!!! Include library
include		..\..\giflib.inc				; !!!! Include header
WinMain 	PROTO STDCALL   :DWORD, :DWORD, :DWORD, :DWORD
WndProc 	PROTO STDCALL   :DWORD, :DWORD, :DWORD, :DWORD

.data?
hInstance	dd	?
TestGif		GIF_INFO	<>

hDCBitmap	dd	?
hBitmap		dd	?


BitmapInfo		BITMAPINFOHEADER	<>
ColorTable		db					32*4 dup (?)

.data
ClassName       db      	"GIFLIB32",0
AppName			db			"GIFLIB file test program",0

GifFileName		db			"test image.gif",0		;!!!! The gif filename	
.code


start:

	; --- Get module handle ---
	invoke	GetModuleHandle, NULL
	mov		hInstance, eax
	
	; --- Load gif file ---
	invoke	GIFLoadResource, ADDR TestGif, hInstance, 800 ; 800 is the resource id of the GIF image
	
	; --- Display window
	invoke	WinMain, hInstance, NULL, NULL, NULL
	invoke	ExitProcess, 0
	

    
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
    LOCAL wc:WNDCLASSEX
    LOCAL hwnd:DWORD
    LOCAL msg:MSG
    mov     wc.cbSize,SIZEOF WNDCLASSEX
    mov     wc.style,   CS_HREDRAW or CS_VREDRAW
    mov     wc.lpfnWndProc, OFFSET WndProc
    mov     wc.cbClsExtra,NULL
    mov     wc.cbWndExtra,NULL
    push    hInst
    pop     wc.hInstance
    mov     wc.hbrBackground,COLOR_WINDOW
    mov     wc.lpszMenuName,NULL
    mov     wc.lpszClassName,OFFSET ClassName
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,   eax
    mov     wc.hIconSm, eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassEx,    addr wc
    invoke	GetSystemMetrics, SM_CYCAPTION	
    mov		ebx, eax
    invoke	GetSystemMetrics, SM_CYFRAME
    add		ebx, eax
    add		ebx, 300
    INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW-WS_SIZEBOX-WS_MAXIMIZEBOX,CW_USEDEFAULT,\
           CW_USEDEFAULT,402,ebx,NULL,NULL,\
           hInst,NULL
    mov   hwnd,eax
    invoke ShowWindow, hwnd, SW_SHOWNORMAL
    invoke UpdateWindow, hwnd
    .WHILE TRUE
        invoke GetMessage, ADDR msg,NULL,0,0
        .BREAK .IF (!eax)
                invoke TranslateMessage, ADDR msg
                invoke DispatchMessage, ADDR msg
    .ENDW
    mov     eax,msg.wParam
    ret
WinMain endp

WndProc proc uses ebx hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
LOCAL	hDC:DWORD
LOCAL	ps:PAINTSTRUCT
LOCAL	bitptr:DWORD
mov eax, uMsg
.IF eax==WM_CREATE
	
	; --- Step 1) Load gif header ---
	invoke	GIFLoadHeader, ADDR TestGif
	
	; --- Step 2) Initalize decoder ---
	invoke	GIFInitalizeDecoder, ADDR TestGif
	
	; --- Create a compatible DC to store the bitmap ---
	invoke	GetDC, hWnd
	mov		ebx, eax
	invoke	CreateCompatibleDC, ebx
	mov		hDCBitmap, eax

	; --- Step 3) Choose a color type (should be at least the minimum type) ---
	invoke	GIFGetMinimumColorType, ADDR TestGif	;get the minimum colortype
	mov		TestGif.dwImageFormat, eax				;and store it

	; --- Fill a BitmapInfoHeader structure automatically ---
	invoke	GIFFillBitmapInfoStruct, ADDR TestGif, ADDR BitmapInfo
	
	; --- Step 4) Store the color table ---
	invoke	GIFGetColorTable, ADDR TestGif, ADDR ColorTable
	
	; --- Create a destination bitmap ---
	invoke	CreateDIBSection, ebx, ADDR BitmapInfo, DIB_RGB_COLORS,\
				 ADDR bitptr, NULL, NULL
	
	; --- Release main window DC and select the bitmap in de device context ---
	mov		hBitmap, eax
	invoke	ReleaseDC,hWnd, ebx
	invoke	SelectObject, hDCBitmap, hBitmap

	; --- Step 5) Set the destination pointer to receive the image data ---
	push	bitptr
	pop		TestGif.lpImageData

	; --- Step 6) Decompress the GIF ---
	invoke	GIFDecompress, ADDR TestGif

.ELSEIF eax==WM_PAINT
	; --- Draw the bitmap on screen ---
	invoke	BeginPaint, hWnd, ADDR ps
	mov		hDC, eax
	; --- Blit it ---
	invoke	BitBlt, eax, 0,0,TestGif.dwImageWidth,TestGif.dwImageHeight,hDCBitmap, 0,0,SRCCOPY
	
	invoke	EndPaint, hWnd, ADDR ps
.ELSEIF eax==WM_DESTROY
	invoke 	PostQuitMessage, NULL
.ELSE
	invoke 	DefWindowProc, hWnd, uMsg, wParam, lParam
.ENDIF
ret
WndProc endp
end start